**Data: 2024-10-10**
**SOFTWARE DIMOSTRATIVO per l'interfacciamento a ai4call.**
**IL SOFTWARE VIENE FORNITO "COSÌ COM'È", SENZA GARANZIE DI ALCUN TIPO, ESPRESSE O IMPLICITE, INCLUSE, MA NON SOLO, LE GARANZIE DI COMMERCIABILITÀ,**
**IN NESSUN CASO GLI AUTORI O I DETENTORI DEI DIRITTI D'AUTORE SARANNO RESPONSABILI DI EVENTUALI RECLAMI, DANNI O ALTRE RESPONSABILITÀ, SIA IN**
**UN'AZIONE LEGALE CHE CONTRATTUALE, EXTRACONTRATTUALE O DI ALTRO TIPO, DERIVANTE DALL'UTILIZZO, ANCHE PARZIALE, DEL SOFTWARE.**

---

# Guida all'utilizzo del progetto AI4Call (Demo WhatsApp)

` Il software è stato testato su Node.js v10.24.0. Si consiglia di utilizzare questa versione per garantire la compatibilità.`

---

## Prerequisito: Account Meta per creare template WhatsApp

Per poter inviare messaggi su WhatsApp utilizzando le API di WhatsApp Business, è necessario disporre di un **account Meta**. Questo account ti permetterà di:

- Configurare e gestire il tuo account WhatsApp Business.
- **Creare e approvare i template** che saranno utilizzati per inviare messaggi.

---

## Prerequisito: Configurazione del firewall

## Se utilizzi un firewall, `assicurati di aggiungere l'IP specifico per permettere il corretto funzionamento delle chiamate in entrata.`

### IP da inserire nel firewall: `20.47.65.96/28`

## Questo passaggio è fondamentale per garantire che le chiamate vengano gestite correttamente dal progetto.

---

## ISTRUZIONI

### 1. Scaricare il file zippato

- Scaricare il file compresso del progetto.

### 2. Estrarre il file

- Estrarre il file zippato nella cartella di destinazione.

### 3. Accedere alla cartella estratta

- Spostarsi nella cartella estratta con il seguente comando:

`cd demo-ws`

### 4. Modificare il file `rest/esempio-rest-dati.js`

Aprire il file `esempio-rest-dati.js` e modificare i seguenti campi
**1°-- Modificare la `(riga 5)` e specificare la porta su cui il progetto deve essere in ascolto**

### 5. Modificare il file `rest/conf.json`

Aprire il file `conf.json` e modificare i seguenti campi:
`1°-- Modificare il numero di telefono con quello assegnato dal progetto ai4call su ai4call.com`
`2°-- Modificare i messaggi a seconda delle preferenze`
`3°-- Modificare il link della pagina di prenotazioni`

### 6. Modificare il file demo-whatsapp.js

Aprire il file `demo-whatsapp.js` e modificare i seguenti campi:
**1°-- Modificare la `(riga 6)` e specificare la `porta` su cui il progetto deve essere in ascolto**

**2°-- Endpoint API WhatsApp `(riga 267)`: Inserire `l'endpoint` rilasciato da Meta:**
"https://graph.facebook.com/v16.0/`[INSERIRE ENDPOINT]`/messages"

**3-- Token di accesso `(riga 269)`: Inserire il `token` fornito da Meta:**
Authorization: Bearer `[INSERIRE TOKEN]`

**4-- Nome del template WhatsApp `(riga 275)`: Inserire il `nome del template` WhatsApp:**
template: {
name: `[INSERIRE NOME TEMPLATE]`,
}

**5-- Inserire la porta `(riga 289)`:**  
Modificare la porta precedentemente specificata nel file `rest/esempio-rest-dati.js`

## const url = http://localhost:[INSERIRE_PORTA]/dati/${recipientNumber};

### 7. Avviare i server Node.js

Eseguire il comando dalla `directory principale` del progetto:
`npm run start`

**NOTA:**
Questo avvierà due server:

## Uno nella cartella rest che legge le configurazioni da un file JSON.

## Un altro che gestisce le chiamate in entrata specificate sul portale beevoip.
